using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Hacker : MonoBehaviour
{
    // Game state
    int level;

    enum Screen { MainMenu, Password, Win };
    Screen currentScreen;

    void Start()
    {
        currentScreen = Screen.MainMenu;
        ShowMainMenu();
    }
    void ShowMainMenu()
    {
        Terminal.ClearScreen();
        Terminal.WriteLine("WELCOME TO E-Z HACKERLITE - EVALUATION TRIAL VERSION");
        Terminal.WriteLine("HACKING IN THE TRIAL VERSION IS LIMITED TO NON-FELONIES ONLY.");
        Terminal.WriteLine("1. Hack the Coke machine in the lobby");
        Terminal.WriteLine("2. Hack the Wifi at McDonald's");
        Terminal.WriteLine("3. Hack the electrical grid");
        Terminal.WriteLine("Enter your selection: ");
    }

    void OnUserInput(string input)
    {
        if (input == "menu") // we can always go direct to main menu
        {
            currentScreen = Screen.MainMenu;
            ShowMainMenu();
        }
        else if (currentScreen == Screen.MainMenu)
        {
            RunMainMenu(input);
        }
        else if (currentScreen == Screen.Password)
        {
            if (CheckPassword(input))
            {
                currentScreen = Screen.Win;
                RunWinScreen();
            }
            else if (!CheckPassword(input))
            {
                Terminal.WriteLine("Incorrect password. Please try again.");
            }
            
        }
    }

    private void RunWinScreen()
    {
        Terminal.ClearScreen();
        Terminal.WriteLine("You win!!");
    }


    private bool CheckPassword(string input)
    {
        bool passwordCorrect = false;
        if(level == 1)
        {
            if (input == "ham"){
                passwordCorrect = true;
            }
        }
        else if(level == 2)
        {
            if (input == "boat")
            {
                passwordCorrect = true;
            }
        }
        return passwordCorrect;
    }

    private void RunMainMenu(string input)
    {

        if (input == "1")
        {
            level = 1;
            currentScreen = Screen.Password;
            StartGame();
        }
        else if (input == "2")
        {
            level = 2;
            currentScreen = Screen.Password;
            StartGame();
        }
        else if (input == "3")
        {
            print("I don't understand that input.");
        }
        else
        {
            print("I don't understand that input.");
        }
    }

    private void StartGame()
    {
        string hint = GetHint(level);
        Terminal.WriteLine("You have chosen level " + level);
        Terminal.WriteLine("Please enter the password: (hint: " + hint + ")");
    }

    private string GetHint(int level)
    {
        string hint = "";
        if (level == 1)
        {
            hint = "mha";
        }
        else if (level == 2)
        {
            hint = "toab";
        }
        return hint;
    }

    // Update is called once per frame
    void Update()
    {


    }
}
